{pro vyhledavani se pouziva modifikace Dexterova algoritmu}
{Startovni cislo  6}
{Ovladani:
 mys - na mape - oznaci dotycne mesto a poskytne informace
 l - (load nacte soubor s mapou
 s - (save) ulozi nalezenou cestu
 c - prepinac zobrazovani hran
 mezernik - vymaze zobrazenou cestu
 x - najde nejkratsi cestu
 y - najde nejrychlejsi cestu
 z - najde cestu s nejmensi spotrebou paliva
 1 - vyberete zacatek cesty
 2 - vyberete konec cesty
  Hledani:
 Nejdrive musite zvolit pocatecni a koncovy bod. Potom muze stisknout
 x/y/z.
  Podstata vyhledavani:
 Vyuziva se modifikace Dexterova algoritmu. Je to nejrychlejsi doposud znamy
 algoritmus pro nejlevnejsi vyhledavani cesty v grafu s ohodnocenymi hranami.
 V podstate se vlnou ze startu siri informace. Ty nesou kolik uz urazili/spo-
 trebovali/hodin jedou a pokud mohou opravi udaj v okolnich mestech a
 pokracuji odsud vlnou. V nejhorsim pripade je casova slozitost
 o(N)=N^2

}
uses crt,graph,mojemys;
type
     pmesto=^tmesto;
     tcesta=record
              kam:pmesto;
              len:longint;
              v:integer;
            end;
     tmesto=record
              name:string[50];
              x,y:longint;
              next:pmesto;
              hran:byte;
              hrany:array[1..100] of tcesta; {kam se muzu dostat}
              k:real; z:pmesto; {pro vyhledavani}
            end;
     trychl=record {rychlosti a spotreby}
              rych:integer; {rychlost}
              litru:real; {spotreba}
            end;
     pfronta=^tfronta;
     tfronta=record
               kde:pmesto; {kde zrovna sem}
               next:pfronta;
             end;

const znaky:set of char=[#32..#255];
      delka=1;
      rychlost=2;
      cena=3;
var gd,gm:integer; {pro grafiku}
    mesta:pmesto;
    eop:boolean; {end of program}
    minx,maxx,miny,maxy,wx,wy:longint; {to je pri prepocitavani na mape}
    rwx,rwy:real; {tohle je taky prepocitavani}
    hrany:boolean; {jsou videt hrany?}
    spotr:array[1..300] of trychl; {spotr jako spotreby - kratsi}
    cspotr:integer; {kolik tech spotreb je}
    trasas,trasae:pmesto;
    mx,my,mb:word;
    typ:byte; {jak vyhledavat}
    fronta,cesta:pfronta;
    clen,crych,ccena:real;

{Ovladani struktury mest --------------------------------------------}

procedure addmesto(name:string; x,y:longint);
var p:pmesto;
begin
  new(p);
  p^.name:=name;
  p^.x:=x;
  p^.y:=y;
  p^.next:=mesta;
  p^.hran:=0;
  mesta:=p;
end;

function getpred(p:pmesto):pmesto;
var pm:pmesto;
begin
  pm:=mesta;
  if p<>pm then
  while (p^.next<>nil) and (p^.next<>p) do
  begin
    pm:=pm^.next;
  end;
  getpred:=pm;
end;

function getname(r:string):pmesto;
var p:pmesto;
begin
  p:=mesta;
  while (p<>nil) and (p^.name<>r) do
  begin
    p:=p^.next;
  end;
  getname:=p;
end;

function vzd(x1,y1,x2,y2:longint):longint;
var a,b:real;
begin
  a:=(x2-x1); if a<0 then a:=-a;
  b:=(y2-y1); if b<0 then b:=-b;
  a:=a*a; b:=b*b;
  vzd:=round(sqrt(a+b));
end;

function getsour(x,y:longint):pmesto;
var p,mp:pmesto;
    k:longint;
begin
  p:=mesta;
  mp:=p;
  k:=100000000;
  while (p<>nil) do
  begin
    if vzd(x,y,p^.x,p^.y)<k then
    begin
      k:=vzd(x,y,p^.x,p^.y);
      mp:=p;
    end;
    p:=p^.next;
  end;
  getsour:=mp;
end;

procedure deletemesto(p:pmesto);
var pp:pmesto;
begin
  if p=mesta then
  begin
    mesta:=mesta^.next;
    dispose(p);
  end else
  begin
    pp:=getpred(p);
    pp^.next:=p^.next;
    dispose(p);
  end;
end;

procedure deletemesta;
begin
  while mesta<>nil do deletemesto(mesta);
end;

procedure dejhranu(co,kam:pmesto; delka,rychl:longint);
begin
  with co^ do
  begin
    inc(hran);
    hrany[hran].kam:=kam;
    hrany[hran].len:=delka;
    hrany[hran].v:=rychl;
  end;
end;
{ovladani struktruy front ---------------------------------------}
procedure addfronta(var fronta:pfronta; kde:pmesto);
var p:pfronta;
begin
  new(p);
  p^.next:=fronta;
  p^.kde:=kde;
  fronta:=p;
end;

function getfronta(var fronta:pfronta):pmesto;
var n:pfronta;
begin
  if fronta<>nil then
  begin
    getfronta:=fronta^.kde;
    n:=fronta^.next;
    dispose(fronta);
    fronta:=n;
  end;
end;

{User Interface ------------------------------------}
procedure help;
begin
  setfillstyle(1,blue);
  bar(500,1,640,480);
  setcolor(white);
  outtextxy(505,1,'l - load souboru');
  outtextxy(505,10,'c - toggle cesty');
  outtextxy(505,20,'1 - zacatek cesty');
  outtextxy(505,30,'2 - konec cesty');
  outtextxy(505,40,'x - kratka cesta');
  outtextxy(505,50,'y - rychla cesta');
  outtextxy(505,60,'z - levna cesta');
  outtextxy(505,70,'s - uloz cestu');
  outtextxy(505,80,'" " - zhasne cestu');
  outtextxy(505,90,'Esc - konec');
end;

procedure GetAtMap(x,y:longint; var outx,outy:integer);
begin
  y:=y-miny;
  x:=x-minx;
  outx:=round(x*rwx);
  outy:=round(y*rwy);
end;

procedure GetAtMem(x,y:integer; var outx,outy:longint);
begin
  x:=round(x/rwx);
  y:=round(y/rwy);
  outy:=y+miny;
  outx:=x+minx;
end;

function vratdoba(t:real):string;
var a:integer;
    b:real;
    hod,min:byte;
    rh,rm,r:string;
begin
  a:=round(int(t));
  b:=(t-a)*60;
  hod:=a;
  min:=round(b);
  str(hod,rh);
  str(min,rm);
  r:=rh+':'+rm;
  vratdoba:=r;
end;


procedure viewmesta;
var p:pmesto;
    x,y,nx,ny:integer;
    i:byte;
begin
  p:=mesta;
  settextstyle(smallfont,horizdir,4);
  settextjustify(lefttext,toptext);
  while p<>nil do
  begin
    setcolor(white);
    GetAtMap(p^.x,p^.y,x,y);
    if hrany then
    if p^.hran>0 then
    for i:=1 to p^.hran do
    begin
      GetAtMap(p^.hrany[i].kam^.x,p^.hrany[i].kam^.y,nx,ny);
      setcolor(darkgray);
      if p^.hrany[i].v>50 then setcolor(lightgray);
      if p^.hrany[i].v>100 then setcolor(yellow);
      if p^.hrany[i].v>150 then setcolor(white);
      line(x,y,nx,ny);
    end;
    p:=p^.next;
  end;
  p:=mesta;
  while p<>nil do
  begin
    GetAtMap(p^.x,p^.y,x,y);
    putpixel(x,y,15);
    setcolor(white);
    outtextxy(x,y,p^.name);
    if p=trasas then
    begin
      setcolor(green);
      circle(x,y,2);
      circle(x,y,3);
      circle(x,y,4);
    end;
    if p=trasae then
    begin
      setcolor(red);
      circle(x,y,4);
      circle(x,y,5);
      circle(x,y,6);
    end;
    p:=p^.next;
  end;
  settextjustify(lefttext,toptext);
  settextstyle(11,horizdir,3);
end;

procedure viewcesta;
var p:pfronta;
    x1,y1,x2,y2:integer;
    r:string;
    rd,rc,rv:string;
begin
  p:=cesta;
  setlinestyle(solidln,0,ThickWidth);
  while p^.next<>nil do
  begin
    GetAtMap(p^.kde^.x,p^.kde^.y,x1,y1);
    GetAtMap(p^.next^.kde^.x,p^.next^.kde^.y,x2,y2);
    setcolor(lightblue);
    line(x1,y1-1,x2,y2-1);
    p:=p^.next;
  end;
  setlinestyle(solidln,0,NormWidth);
  setcolor(white);
  str(clen:2:3,rd);
  rv:=vratdoba(crych);
  str(ccena:2:3,rc);
  r:='Delka: '+rd+'  Doba:'+rv+' hod  Cena:'+rc;
  outtextxy(1,470,r);
end;

procedure obr;
begin
  help;
  viewmesta;
  if (cesta<>nil) and (trasas<>nil) and (trasae<>nil) then
   viewcesta;
end;

function getret:string;
var r:string;
    z:char;
begin
  m_off;
  r:='';
  setfillstyle(1,darkgray);
  setcolor(white);
  repeat
  bar(1,450,640,480);
  outtextxy(5,455,r);
  z:=readkey;
  if z in znaky then r:=r+z else
  if z=#8 then delete(r,length(r),1);
  until z=#13;
  getret:=r;
  help;
  m_on;
end;

{NACITANI ------------------------------------}

procedure nacitej;
var name:string;
    s:text;
    r:string;
    r_mapa:boolean;

procedure ctifile(var r:string);
begin
  readln(s,r);
  while r[1]=' ' do delete(r,1,1);
end;

procedure ctimesto;
var name:string;
    x,y:longint;
    err:integer;
begin
  while r<>'</mesto>' do
  begin
    ctifile(r);
    if pos('<nazev>',r)>0 then
    begin
      delete(r,pos('<nazev>',r),length('<nazev>'));
      delete(r,pos('</nazev>',r),length('</nazev>'));
      name:=r;
    end;
    if pos('<polohaX>',r)>0 then
    begin
      delete(r,pos('<polohaX>',r),length('<polohaX>'));
      delete(r,pos('</polohaX>',r),length('</polohaX>'));
      val(r,x,err);
    end;
    if pos('<polohaY>',r)>0 then
    begin
      delete(r,pos('<polohaY>',r),length('<polohaY>'));
      delete(r,pos('</polohaY>',r),length('</polohaY>'));
      val(r,y,err);
    end;
  end;
  addmesto(name,x,y);
end;

procedure cticestu;
var name:string;
    len,v:longint;
    err:integer;
    z,kam:pmesto;
begin
  while r<>'</cesta>' do
  begin
    ctifile(r);
    if pos('<z>',r)>0 then
    begin
      delete(r,pos('<z>',r),length('<z>'));
      delete(r,pos('</z>',r),length('</z>'));
      name:=r;
      z:=getname(name);
    end;
    if pos('<do>',r)>0 then
    begin
      delete(r,pos('<do>',r),length('<do>'));
      delete(r,pos('</do>',r),length('</do>'));
      name:=r;
      kam:=getname(name);
    end;
    if pos('<vzdalenost>',r)>0 then
    begin
      delete(r,pos('<vzdalenost>',r),length('<vzdalenost>'));
      delete(r,pos('</vzdalenost>',r),length('</vzdalenost>'));
      val(r,len,err);
    end;
    if pos('<prumernaRychlost>',r)>0 then
    begin
      delete(r,pos('<prumernaRychlost>',r),length('<prumernaRychlost>'));
      delete(r,pos('</prumernaRychlost>',r),length('</prumernaRychlost>'));
      val(r,v,err);
    end;
  end;
  dejhranu(z,kam,len,v);
  dejhranu(kam,z,len,v);
end;

procedure ctispotrebu;
var rych:longint;
    litru:real;
    err:integer;
begin
  while r<>'</spotreba>' do
  begin
    ctifile(r);
    if pos('<rychlost>',r)>0 then
    begin
      delete(r,pos('<rychlost>',r),length('<rychlost>'));
      delete(r,pos('</rychlost>',r),length('</rychlost>'));
      val(r,rych,err);
    end;
    if pos('<litru>',r)>0 then
    begin
      delete(r,pos('<litru>',r),length('<litru>'));
      delete(r,pos('</litru>',r),length('</litru>'));
      val(r,litru,err);
    end;
  end;
  inc(cspotr);
  spotr[cspotr].rych:=rych;
  spotr[cspotr].litru:=litru;
end;
var p:pmesto;

begin
  minx:=100000;
  miny:=100000;
  maxx:=-100000;
  maxy:=-100000;
  cspotr:=0;
  trasas:=nil; trasae:=nil;
  while cesta<>nil do getfronta(cesta);
  deletemesta;
  setcolor(white);
  outtextxy(1,430,'Zadejte cestu a nazev k souboru(i s .xml):');
  name:=getret;
  {$I-}
  assign(s,name);
  reset(s);
  r_mapa:=false;
  while not eof(s) do
  begin
    ctifile(r);
    if r='<mapa>' then r_mapa:=true;
    if r='</mapa>' then r_mapa:=true;
    if r_mapa then
    begin
      if r='<mesta>' then
      while r<>'</mesta>' do
      begin
        ctifile(r);
        if r='<mesto>' then ctimesto;
      end;
      if r='<cesty>' then
      while r<>'</cesty>' do
      begin
        ctifile(r);
        if r='<cesta>' then cticestu;
      end;
      if r='<spotreby>' then
      while r<>'</spotreby>' do
      begin
        ctifile(r);
        if r='<spotreba>' then ctispotrebu;
      end;
    end;
  end;
  close(s);
  p:=mesta;
  while p<>nil do
  begin
    if p^.x<minx then minx:=p^.x;
    if p^.x>maxx then maxx:=p^.x;
    if p^.y<miny then miny:=p^.y;
    if p^.y>maxy then maxy:=p^.y;
    p:=p^.next;
  end;
  wx:=maxx-minx;
  wy:=maxy-miny;
  if wx=0 then wx:=1;
  if wy=0 then wy:=1;
  rwx:=450/wx;
  rwy:=450/wy;
  if rwx<rwy then rwy:=rwx else rwx:=rwy;
  m_off;
  cleardevice;
  obr;
  m_on;
  {$I+}
end;

{UI ---------------------------------------------------------------}

procedure info(co:pmesto);
var x,y,nx,ny:integer;
    i:byte;
    r,rdoba,rdelka:string;
    t:real;
begin
  m_off;
  cleardevice;
  obr;
  GetAtMap(co^.x,co^.y,x,y);
  setcolor(white);
  settextstyle(smallfont,horizdir,4);
  settextjustify(centertext,toptext);
  outtextxy(550,100,co^.name);
  settextjustify(lefttext,toptext);
  r:='';
  for i:=1 to co^.hran do
  begin
    r:=co^.hrany[i].kam^.name;
    t:=co^.hrany[i].len/co^.hrany[i].v;
    str(t:2:2,rdoba);
    str(co^.hrany[i].len,rdelka);
    r:='do:'+r+' Km:'+rdelka+' Hod:'+rdoba;
    setfillstyle(1,magenta);
    bar(470,100+i*10,640,100+i*10+10);
    setcolor(white);
    outtextxy(470,100+i*10,r);
    GetAtMap(co^.hrany[i].kam^.x,co^.hrany[i].kam^.y,nx,ny);
    setcolor(blue);
    line(x,y,nx,ny);
  end;
  settextstyle(11,horizdir,4);
  m_on;
  m_set(x,y);
end;

function getmesto(r:string):pmesto;
var x,y:longint;
    nx,ny:integer;
    p:pmesto;
begin
  m_off;
  setcolor(white);
  outtextxy(1,470,'Ted si vyberte mesto '+r+' - mysi! :-)');
  rectangle(0,0,450,450);
  m_on;
  repeat
  m_stav(mx,my,mb);
  until (mb and 1)>0;
  while (mb and 1)>0 do m_stav(mx,my,mb);
  GetAtMem(mx,my,x,y);
  p:=GetSour(x,y);
  GetAtMap(p^.x,p^.y,nx,ny);
  getmesto:=p;
  m_set(nx,ny);
end;

{Hledani cest ----(Dexteruv algoritmus)------------------------}

function cenarychlost(v:real):real;
var m,i:byte;
begin
  m:=1;
  for i:=1 to cspotr do
  if abs(spotr[i].rych-v)<abs(spotr[m].rych-v) then
  begin
    m:=i;
  end;
  cenarychlost:=spotr[m].litru;
end;

function zjistik(a,b:pmesto; hrana:byte):real; {vrati cenu chuze po dane hrane grafu}
var r:real;
begin
  r:=0;
  case typ of
  delka:r:=a^.hrany[hrana].len;
  rychlost:r:=a^.hrany[hrana].len/a^.hrany[hrana].v;
  cena:begin                                   {protoze je to na 100km}
         r:=cenarychlost(a^.hrany[hrana].v)*(a^.hrany[hrana].len/100);
       end;
  end;
  zjistik:=r;
end;

procedure find(jak:byte);
var p,kam:pmesto;
    i,m:byte;
begin
  while cesta<>nil do getfronta(cesta);
  if trasas^.hran=0 then exit;
  if trasae^.hran=0 then exit;
  typ:=jak;
  fronta:=nil;
  p:=mesta;
  while p<>nil do
  begin
    p^.k:=100000;
    p^.z:=nil;
    p:=p^.next;
  end;
  trasas^.k:=0;
  trasas^.z:=trasas;
  addfronta(fronta,trasas);
  while fronta<>nil do
  begin
    p:=getfronta(fronta);
    for i:=1 to p^.hran do
    begin
      kam:=p^.hrany[i].kam;
      if kam^.k>(p^.k+zjistik(p,kam,i)) then
      begin
        kam^.k:=p^.k+zjistik(p,kam,i);
        kam^.z:=p;
        addfronta(fronta,kam);
      end;
    end;
  end;
  if trasae^.k=100000 then exit;
  p:=trasae;
  cesta:=nil;
  clen:=0;
  crych:=0;
  ccena:=0;
  while cesta^.kde<>trasas do
  begin
    m:=1;
    for i:=1 to p^.hran do
    begin
      if p^.hrany[i].kam=p^.z then m:=i;
    end;
    typ:=delka;
    clen:=clen+zjistik(p,p^.hrany[m].kam,m);
    typ:=rychlost;
    crych:=crych+zjistik(p,p^.hrany[m].kam,m);
    typ:=cena;
    ccena:=ccena+zjistik(p,p^.hrany[m].kam,m);
    addfronta(cesta,p);
    p:=p^.hrany[m].kam;
  end;
  typ:=jak;
  m_off;
  cleardevice;
  obr;
  m_on;
end;

{UKLADANI cesty--------------------------------}
procedure savecesta;
var name:string;
    s:text;
    p:pfronta;
begin
  m_off;
  setcolor(white);
  outtextxy(1,430,'Zadejte cestu a nazev k souboru(i s .xml):');
  name:=getret;
  m_on;
  {$I-}
  assign(s,name);
  rewrite(s);
  append(s);
  writeln(s,'<?xml version="1.0" encoding="windows-1250"?>');
  writeln(s,'<cesta>');
  writeln(s,'<z>',trasas^.name,'</z>');
  writeln(s,'<z>',trasae^.name,'</z>');
  p:=cesta;
  while p<>nil do
  begin
    writeln(s,'<pres>',p^.kde^.name,'</pres>');
    p:=p^.next;
  end;
  writeln(s,'<vzdalenost>',clen:3:3,'</vzdalenost>');
  writeln(s,'<dobaJizdy>',vratdoba(crych),'</dobaJizdy>');
  writeln(s,'<spotreba>',ccena:3:3,'</spotreba>');
  writeln(s,'</cesta>');
  close(s);
  {$I+}
  m_off;
  cleardevice;
  obr;
  m_on;
end;

{HLAVNI PROGRAM----------------------------------}

var p:pmesto;
    x,y:longint;
    z:char;
begin
  mesta:=nil;
  gd:=0;
  initgraph(gd,gm,'c:\bp\bgi');
  eop:=false;
  hrany:=true;
  trasas:=nil; trasae:=nil;
  cesta:=nil;
  obr;
  m_on;
  repeat
  if keypressed then
  begin
    z:=readkey;
    case z of
    #27:eop:=true;
    'l':nacitej;
    'c':begin hrany:=not hrany; m_off; cleardevice; obr; m_on; end;
    '1':begin
          trasas:=getmesto('startu');
          m_off;
          cleardevice;
          obr;
          m_on;
        end;
    '2':begin
          trasae:=getmesto('konce');
          m_off;
          cleardevice;
          obr;
          m_on;
        end;
    'x':if (trasas<>trasae) and (trasas<>nil) and (trasae<>nil) then
           find(delka);
    'y':if (trasas<>trasae) and (trasas<>nil) and (trasae<>nil) then
           find(rychlost);
    'z':if (trasas<>trasae) and (trasas<>nil) and (trasae<>nil) then
           find(cena);
    's':if cesta<>nil then
        savecesta;
    ' ':begin while cesta<>nil do getfronta(cesta); m_off; cleardevice; obr; m_on; end;
    end;
  end;
  m_stav(mx,my,mb);
  if (mb and 1)>0 then
  if (mx<450) and (my<450) then
  if mesta<>nil then
  begin
    GetAtMem(mx,my,x,y);
    p:=GetSour(x,y);
    while (mb and 1)>0 do m_stav(mx,my,mb);
    Info(p);
  end;
  until eop;
  m_off;
  closegraph;
  deletemesta;
  while cesta<>nil do getfronta(cesta);
end.